<?php
global $PluginConfig;

$message=preg_replace("/\x3([0-9]{1,2})((,([0-9]{1,2}))?)/","",$data->message);	#colors
$message=preg_replace("/[\x1\x2\x9\xa\xd\xf\x16\x1f]/","",$message); 		#ctcp delimiter,boldtext,tab,lf,cr,normaltext,reversedtext,underlinedtext
$words=explode(" ",strtolower("$message "));

if ( strlen($message) > 400 )
{
	say("IRC::Message from ".$data->nick." exceed maximum length");
}
elseif ( $words[0]=="!help" )
{
	$message="Hi, this is an AoC guildrelay. Features: !online, !whois. (Ragebot)";
	$this->message(SMARTIRC_TYPE_CHANNEL, $data->channel, $message);
}
elseif ( $words[0]=="!online" )
{
	global $BuddyList,$guildmates;
	$BuddyClasses=array(); foreach($BuddyList as $buddy) $BuddyClasses[]=$buddy["class"];
	$BuddySorted =$BuddyList;
	array_multisort($BuddyClasses,SORT_ASC,$BuddySorted);
	$message="Currently online: \x03".$PluginConfig["irc"]["IRCnickcolor"]; $n=0;
	foreach ($BuddySorted as $buddy) {
		if ( $guildmates[$buddy["name"]] && $buddy["status"]>0 ) {
			if (++$n!=1) {
				$message.=" :: ";
			}
			$message.=$buddy["name"];
		}
	}
	if ($n>0) {
		$this->message(SMARTIRC_TYPE_CHANNEL, $data->channel, $message);
	} else {
		$this->message(SMARTIRC_TYPE_CHANNEL, $data->channel, "Sorry ".$data->nick.", there's nobody only yet.");
	}
}
elseif ( $words[0]=="!whois" )
{
	global $AOC,$IRCWhoIs,$BuddyList;
	$message="";
	if ( $words[1] && preg_match('#^[a-z]+$#i',$words[1]) )
	{
		$whois=strtoupper(substr($words[1],0,1)).strtolower(substr($words[1],1));
		$cid=$AOC->lookup_user($whois);
		if (!isset($BuddyList[$cid]))
		{
			$IRCWhoIs[$whois]=$data->channel;
			if (!($AOC->buddy_add($whois))) 
			{
				$message="Not a known charactername \"$whois\"!";
			} 
		}
		else
		{
			$message=
				chr(3).$PluginConfig["irc"]["IRCnickcolor"]."$whois ".chr(15).
				" :: Level ".$BuddyList[$cid]["level"].
				" ".classname($BuddyList[$cid]["class"]).
				" is ".(($BuddyList[$cid]["status"] == 0) ? "offline" : "online");
		}
	} 
	else 
	{
		$message="Usage: !whois <charactername>";
	}
	if ($message)
	{
		$this->message(SMARTIRC_TYPE_CHANNEL, $data->channel, $message);
	}
}
elseif ( $PluginConfig["irc"]["guildrelay"] )
{
	say("IRC::Message from ".$data->nick." sent to guild",1);
    global $myguild;
	global $queue;
    $message_to_put_on_queue["type"]        ="public channel message";
    $message_to_put_on_queue["channel name"]="$myguild";
    $message_to_put_on_queue["blob"]        ="";
    $message_to_put_on_queue["message"] =
		"<font color='".$PluginConfig["irc"]["AOCnickcolor"]."'>".
		$data->nick.": ".
		"</font>".
        strtr(
            $message,
            array("" => "__","" => "___","" => "___","" => "_","" => "_","" => "_","" => "_")
            )
		;
    $queue[]=$message_to_put_on_queue;
}
